"""
Python translation of fit..
which is copyright (c) 2002 Cunningham & Cunningham, Inc.
Released under the terms of the GNU General License version 2 or later.
"""

import fileinput

class Music:

    library = []       # static
    looking = None     # static
    playing = None     # static

    title = ''
    artist = ''
    album = ''
    genre = ''
    size = 0
    _time = 0
    trackNumber = 0
    trackCount = 0
    year = 0
    date = ''
    selected = 0

    ## Accessors ################################

    def track(self):
        return "%s of %s" % (self.trackNumber,self.trackCount)

    def time(self):
        return round(self._time / 0.6) / 100.0

    def __str__(self):
        if self.title:
            return self.title
        else:
            return repr(self)

    ## Factory ##################################

    def load(self, name):
        lines = open(name).readlines()
        self.__class__.library = []
        for line in lines[1:]:
            self.__class__.library.append(self.parse(line))

    #dateFormat = SimpleDateFormat("M/d/yy h:mm a")

    def parse(self, string):
        m = Music()
        t = string.split('\t')
        m.title =       t[0]
        m.artist =      t[1]
        m.album =       t[2]
        m.genre =       t[3]
        m.size =        int(t[4])
        m._time =       int(t[5])
        m.trackNumber = int(t[6])
        m.trackCount =  int(t[7])
        m.year =        int(t[8])
        m.date =        t[9]
        return m

    ## Library ##################################

    def select(self, m):
        self.__class__.looking = m

    def play(self, m):
        ## nothing yet
        pass

    def findAll(self):
        for i in self.library:
            i.selected = 1

    def findArtist(self,a):
        for i in self.library:
            i.selected = (i.artist == a)

    def findAlbum(self, a):
        for i in self.library:
            i.selected = (i.album == a)

    def findGenre(self, a):
        for i in self.library:
            i.selected = (i.genre == a)
        
    def findYear(self, a):
        for i in self.library:
            i.selected = (i.year == a)

    def displayCount(self):
        return len(filter(lambda x:x.selected,self.library))
    
    def displayContents (self):
        return filter(lambda x:x.selected,self.library)
