"""
Python translation of fit..
which is copyright (c) 2002 Cunningham & Cunningham, Inc.
Released under the terms of the GNU General Public License version 2 or later.
"""

import string, re, time
from types import *
from fit.Parse import Parse, ParseException
from fit.Fixture import Fixture
from fit.TypeAdapter import adapterOnType, adapterOnField, adapterOnMethod

class NoSuchMethodException(Exception):
    pass

class ActionFixture(Fixture):
    """
    """
    cells = None
    actor = None
    empty = []

    ## Traversal ################################

    #public void doCells(Parse cells) {
    def doCells(self, cells):
        self.cells = cells
        try:
            # calls instance method - import to look up class method
            # (and call with empty instance ?) as java does ?
            # add a _ to these to avoid hiding Fixture.check
            getattr(self,cells.text()+'_')()
        except Exception, e:
            self.exception(cells, e)
        
    ## Actions ##################################

    #public void start() throws Exception {
    def start_(self):
        #how does this work in java ?
        #self.actor = eval(self.cells.more.text()+'()')
        path = self.cells.more.text()
        clas = path.split('.')[-1]
        exec 'import '+path
        exec 'self.__class__.actor = '+path+'.'+clas+'()'

    #public void enter() throws Exception {
    def enter_(self):
        method = self.method(1)
        type = StringType #method.getParameterTypes()[0]
        text = self.cells.more.more.text()
        args = adapterOnType(self.actor,type).parse(text)
        method(self.actor,args)

    #public void press() throws Exception {
    def press_(self):
        self.method(0)(self.actor)

    #public void check() throws Exception {
    def check_(self):
        adapter = adapterOnMethod(self.actor, self.method(0))
        Fixture.check(self, self.cells.more.more, adapter)

    ## Utility ##################################

    #Method method(int args) throws NoSuchMethodException {
    def method(self,args):
        #methods = filter(callable,
        #                 map(lambda x:getattr(self.actor.__class__,x),
        #                     dir(self.actor.__class__)))
        methods = []
        for name in dir(self.actor.__class__):
            attr = getattr(self.actor.__class__,name)
            if callable(attr):
                methods.append(attr)
        test = self.camel(self.cells.more.text())
        for m in methods:
            if (m.im_func.__name__ == test and 
                m.im_func.func_code.co_argcount == 1+args):
                return m
        raise NoSuchMethodException
