"""
Python translation of fit..
which is copyright (c) 2002 Cunningham & Cunningham, Inc.
Released under the terms of the GNU General Public License version 2 or later.
"""

import string, re, time
from fit.Parse import Parse
from fit.Fixture import Fixture
from fit.TypeAdapter import adapterOnType, adapterOnField, adapterOnMethod

class NoSuchMethodException(Exception):
    pass

class ColumnFixture(Fixture):
    """
    """
    columnBindings = []

    ## Traversal ################################

    def doRows(self, rows):
        self.bind(rows.parts)
        Fixture.doRows(self,rows.more)

    def doCell(self, cell, column):
        a = self.columnBindings[column]
        try:
            if not a:
                self.ignore(cell)
            elif a.field:
                text = cell.text()
                if text:
                    a.set(a.parse(text))
            elif a.method:
                self.check(cell, a)
        except Exception, e:
            self.exception(cell, e)

    ## Utility ##################################

    def bind (self, heads):
        self.columnBindings = [None] * heads.size()
        i = 0
        while heads:
            name = heads.text()
            sufix = "()"
            try:
                if name[-len(sufix):] == sufix:
                    self.columnBindings[i] = \
                        self.bindMethod(name[:-len(sufix)])
                else:
                    self.columnBindings[i] = self.bindField(name)
            except Exception, e:
                self.exception(heads, e)
            heads = heads.more
            i += 1
                
    def bindMethod(self, name):
        methods = []
        for attrname in dir(self.getTargetClass()):
            attr = getattr(self.getTargetClass(),attrname)
            if callable(attr):
                methods.append(attr)
        for m in methods:
            if (m.im_func.__name__ == name and 
                m.im_func.func_code.co_argcount == 1):
                return adapterOnMethod(self,m)
        raise NoSuchMethodException

    def bindField (self, name):
        return adapterOnField(self, name, self.getTargetClass())

    def getTargetClass(self):
        return self.__class__
