"""
Python translation of fit..
which is copyright (c) 2002 Cunningham & Cunningham, Inc.
Released under the terms of the GNU General Public License version 2 or later.
"""

import string, re, time, sys, traceback

class Fixture:
    """
    """
    rights = 0
    wrongs = 0
    ignores = 0
    exceptions = 0
    summary = {}

    ## Traversal ##########################

    #public void doTables(Parse tables) {
    def doTables(self,tables) :
        Fixture.summary["run date"] = time.ctime(time.time())
        while tables:
            heading = tables.at(0,0,0)
            if heading:
                try:
                    path = heading.text()
                    #path = re.sub(r'^fit\.','',path) #try to cure the fits of madness
                    clas = path.split('.')[-1]
                    exec 'import '+path
                    exec 'fixture = '+path+'.'+clas+'()'
                    fixture.doTable(tables)
                except Exception, e:
                    self.exception(heading, e)
            tables = tables.more
    
    #public void doTable(Parse table) {
    def doTable(self,table):
        self.doRows(table.parts.more)
    
    #public void doRows(Parse rows) {
    def doRows(self, rows) :
        while rows:
            self.doRow(rows)
            rows = rows.more

    #public void doRow(Parse row) {
    def doRow(self, row) :
        self.doCells(row.parts)
    
    #public void doCells(Parse cells) {
    def doCells(self, cells) :
        i = 0
        while cells:
            try:
                self.doCell(cells, i)
                i = i + 1
            except Exception, e:
                self.exception(cells, e)
            cells=cells.more
        
    #public void doCell(Parse cell, int columnNumber) {
    def doCell(self, cell, columnNumber) :
        self.ignore(cell)

    ## Annotation ##############################/

    #public static void right (Parse cell) {
    def right (self, cell, actual=None) :
        cell.addToTag(" bgcolor=\"#cfffcf\"")
	Fixture.rights += 1
        if actual != None:
            cell.addToBody(self.greenlabel("expected") + "<hr>" + \
                           self.escape(actual) + self.greenlabel("actual"))

    #public static void wrong (Parse cell) {
    #public static void wrong (Parse cell, String actual) {
    def wrong (self, cell, actual=None) :
        cell.addToTag(" bgcolor=\"#ffcfcf\"")
        Fixture.wrongs += 1
        if actual != None:
            cell.addToBody(self.label("expected") + "<hr>" + \
                           self.escape(actual) + self.label("actual"))
    
    #public static void ignore (Parse cell) {
    def ignore (self, cell) :
        cell.addToTag(" bgcolor=\"#efefef\"")
        Fixture.ignores += 1

    #public static void exception (Parse cell, Exception exception) {
    def exception(self, cell, exception) :
        type, val, tb = sys.exc_info()
        err = string.join(traceback.format_exception(type,val,tb),'')
        cell.addToBody("<hr><font size=-2><pre>%s</pre></font>" % err)
        cell.addToTag(" bgcolor=\"#ffffcf\"")
        Fixture.exceptions += 1
    
    ## Utility ##################################

    #public static String counts() {
    def counts(self) :
        return "%s right, %s wrong, %s ignored, %s exceptions" \
            % (Fixture.rights,Fixture.wrongs,
               Fixture.ignores,Fixture.exceptions)

    #static String label (String string) {
    def label (self,string) :
        return " <font size=-1 color=#c08080><i>%s</i></font>" % string

    def greenlabel(self,string) :
        return " <font size=-1 color=#80c080><i>%s</i></font>" % string

    #static String escape (String string) {
    #static String escape (String string, char from, String to) {
    def escape (self, thestring, old=None, new=None) :
        if old==None:
            return self.escape(self.escape(thestring,'&',"&amp;"),'<',"&lt;")
        else:
            #return thestring.replace(old,new)
            return str(thestring).replace(old,new)

    # not sure what exactly this needs to do
    #static String camel (String name) {
    def camel (self, name) :
        b = ''
        token = re.compile('\w+')
        match = token.search(name)
        if match: b += match.group()
        while 1:
            match = token.search(name,match.end())
            if match:
                t = match.group()
                b += t[0].upper() + t[1:]
            else: break
        return b
    
    #public Object parse (String s, Class type) throws Exception {
    def parse (self, s, type):
        return s

    #void check(Parse cell, TypeAdapter a) {
    def check(self, cell, a):
        text = cell.text()
        if text == "" :
            return
        if text == "error":
            try:
                result = a.invoke()
                self.wrong(cell, a.toString(result))
            #except IllegalAccessException, e:
            #    self.exception(cell, e)
            except Exception, e:
                self.right(cell)
            return
        try:
            #match parsed expect
            expected = a.parse(text)
            result = a.get()
            #match raw expect
            #expected = text
            #result = repr(a.get())
            if a.equals(expected, result):
                #sys.stderr.write(' \tok\n')
                #self.right(cell)
                if repr(expected) != repr(result):
                    self.right(cell, a.toString(result))
                else:
                    self.right(cell)
            else:
                #sys.stderr.write(' \tFAIL\n')
                self.wrong(cell, a.toString(result))
        except Exception, e :
            self.exception(cell, e)
