"""
Python translation of fit..
which is copyright (c) 2002 Cunningham & Cunningham, Inc.
Released under the terms of the GNU General Public License version 2 or later.
"""

from fit.Parse import Parse, ParseException
from fit.Fixture import Fixture

class Summary(Fixture):

    def doTable(self, table):
        Fixture.summary["counts"] = self.counts()
        table.parts.more = self.rows(self.summary.keys())

    def rows(self, keys):
        if len(keys) > 0:
            key = keys[0]
            return self.tr(
                    self.td(key,
                            self.td(self.summary[key],
                                    None)),
                    self.rows(keys[1:]))
        else:
            return None

    def tr(self, parts, more):
        return Parse(tag="tr", body=None, parts=parts, more=more)

    def td(self, body, more):
        return Parse(tag="td", body=body, parts=None, more=more)
